# Make figures of posterior predictive simulation
# 180421 Adjust figure size
require(ggplot2)
require(reshape)

d.sim <- read.table(file = "sumstat.txt", header = TRUE)
d.sim <- d.sim[d.sim$H_1 != 0,] # Remove bad simulations
d.obs <- read.table(file = "/Users/ichiro/works/works14/aoki/abc_fsc2/observed/observed_castanopsis4pop100ind.txt", header = TRUE)

use.ss <- names(d.sim)

d.sim <- d.sim[, use.ss]
d.obs <- d.obs[, use.ss]

hist.data <- melt(d.sim)
vline.data <- melt(d.obs)

## Set lables for facet
levels(hist.data$variable)[levels(hist.data$variable) == "K_1"] <- "Average A1"
levels(hist.data$variable)[levels(hist.data$variable) == "Ksd_1"] <- "SD of A1"
levels(hist.data$variable)[levels(hist.data$variable) == "H_1"] <- "Average H1"
levels(hist.data$variable)[levels(hist.data$variable) == "Hsd_1"] <- "SD of H1"
levels(hist.data$variable)[levels(hist.data$variable) == "R_1"] <- "Average R1"
levels(hist.data$variable)[levels(hist.data$variable) == "Rsd_1"] <- "SD of R1"

levels(hist.data$variable)[levels(hist.data$variable) == "K_2"] <- "Average A2"
levels(hist.data$variable)[levels(hist.data$variable) == "Ksd_2"] <- "SD of A2"
levels(hist.data$variable)[levels(hist.data$variable) == "H_2"] <- "Average H2"
levels(hist.data$variable)[levels(hist.data$variable) == "Hsd_2"] <- "SD of H2"
levels(hist.data$variable)[levels(hist.data$variable) == "R_2"] <- "Average R2"
levels(hist.data$variable)[levels(hist.data$variable) == "Rsd_2"] <- "SD of R2"

levels(hist.data$variable)[levels(hist.data$variable) == "K_3"] <- "Average A3"
levels(hist.data$variable)[levels(hist.data$variable) == "Ksd_3"] <- "SD of A3"
levels(hist.data$variable)[levels(hist.data$variable) == "H_3"] <- "Average H3"
levels(hist.data$variable)[levels(hist.data$variable) == "Hsd_3"] <- "SD of H3"
levels(hist.data$variable)[levels(hist.data$variable) == "R_3"] <- "Average R3"
levels(hist.data$variable)[levels(hist.data$variable) == "Rsd_3"] <- "SD of R3"

levels(hist.data$variable)[levels(hist.data$variable) == "K_4"] <- "Average A4"
levels(hist.data$variable)[levels(hist.data$variable) == "Ksd_4"] <- "SD of A4"
levels(hist.data$variable)[levels(hist.data$variable) == "H_4"] <- "Average H4"
levels(hist.data$variable)[levels(hist.data$variable) == "Hsd_4"] <- "SD of H4"
levels(hist.data$variable)[levels(hist.data$variable) == "R_4"] <- "Average R4"
levels(hist.data$variable)[levels(hist.data$variable) == "Rsd_4"] <- "SD of R4"

levels(vline.data$variable)[levels(vline.data$variable) == "K_1"] <- "Average A1"
levels(vline.data$variable)[levels(vline.data$variable) == "Ksd_1"] <- "SD of A1"
levels(vline.data$variable)[levels(vline.data$variable) == "H_1"] <- "Average H1"
levels(vline.data$variable)[levels(vline.data$variable) == "Hsd_1"] <- "SD of H1"
levels(vline.data$variable)[levels(vline.data$variable) == "R_1"] <- "Average R1"
levels(vline.data$variable)[levels(vline.data$variable) == "Rsd_1"] <- "SD of R1"

levels(vline.data$variable)[levels(vline.data$variable) == "K_2"] <- "Average A2"
levels(vline.data$variable)[levels(vline.data$variable) == "Ksd_2"] <- "SD of A2"
levels(vline.data$variable)[levels(vline.data$variable) == "H_2"] <- "Average H2"
levels(vline.data$variable)[levels(vline.data$variable) == "Hsd_2"] <- "SD of H2"
levels(vline.data$variable)[levels(vline.data$variable) == "R_2"] <- "Average R2"
levels(vline.data$variable)[levels(vline.data$variable) == "Rsd_2"] <- "SD of R2"

levels(vline.data$variable)[levels(vline.data$variable) == "K_3"] <- "Average A3"
levels(vline.data$variable)[levels(vline.data$variable) == "Ksd_3"] <- "SD of A3"
levels(vline.data$variable)[levels(vline.data$variable) == "H_3"] <- "Average H3"
levels(vline.data$variable)[levels(vline.data$variable) == "Hsd_3"] <- "SD of H3"
levels(vline.data$variable)[levels(vline.data$variable) == "R_3"] <- "Average R3"
levels(vline.data$variable)[levels(vline.data$variable) == "Rsd_3"] <- "SD of R3"

levels(vline.data$variable)[levels(vline.data$variable) == "K_4"] <- "Average A4"
levels(vline.data$variable)[levels(vline.data$variable) == "Ksd_4"] <- "SD of A4"
levels(vline.data$variable)[levels(vline.data$variable) == "H_4"] <- "Average H4"
levels(vline.data$variable)[levels(vline.data$variable) == "Hsd_4"] <- "SD of H4"
levels(vline.data$variable)[levels(vline.data$variable) == "R_4"] <- "Average R4"
levels(vline.data$variable)[levels(vline.data$variable) == "Rsd_4"] <- "SD of R4"

## Make ggplot
g <- ggplot(data = hist.data, aes(x = value)) +
    xlab("Parameter") +
    ylab("Count") +
    geom_histogram(alpha = 0.6) +
    facet_wrap(~ variable, ncol = 4, scales = "free") +
    geom_vline(aes(xintercept = value), data = vline.data) +
    theme_bw()

pdf(file = "posterior_pred180421.pdf", width = 9, height = 13.5)
print(g)
dev.off()


