#!/bin/bash
# Run fsc2 for posterior predictive simulation

tplfile="../model2C.tpl"
outfile="sumstat.txt"

## Run fsc2
fsc="/Users/ichiro/works/programs/fsc_mac64/fsc25221"
$fsc -t $tplfile -n 1 -f ./posterior.txt -g

## Calculate sumstat using arlsumstat
tempdir=${tplfile##*/}
tempdir=${tempdir%.*}
cd $tempdir
cp /Users/ichiro/works/programs/arlsumstat_macosx/arlsumstatmac_64bit arlsumstat
cp /Users/ichiro/works/works14/aoki/abc_fsc2/observed/arl_run.ars .
cp /Users/ichiro/works/works14/aoki/abc_fsc2/observed/ssdefs.txt .

counter=1;
for arpfile in *.arp
do
    echo "Processing file $arpfile"
    if [ $counter -eq 1 ]; then
        # Calculate sumstat, then reset outfile and add header
        ./arlsumstat ./$arpfile $outfile 0 1
    else
        # Calculate sumstat and add them to the outfile
        ./arlsumstat ./$arpfile $outfile 1 0
    fi
    let counter=counter+1
done
# Cleaning
mv $outfile ../
cd ../
rm -rf $tempdir
rm seed.txt
rm ../*.par

