# Make figures of prior and posterior distributions of model2C
library(reshape)
library(ggplot2)

if(0) {
load("/Users/ichiro/works/works14/aoki/abc_fsc2/model2C/param_est/posterior.RData")
posterior <- as.data.frame(res$adj.values)
prior <- read.table(file = "/Users/ichiro/works/works14/aoki/abc_fsc2/model2C/param_est/prior.txt", header = TRUE)
}

if(1) {
## Adjust data for ggplot
gdPosterior <- melt(posterior)
names(gdPosterior) <- c("Parameter", "Value")

gdPrior <- melt(prior)
names(gdPrior) <- c("Parameter", "Value")

gd <- rbind(gdPosterior, gdPrior)
gd$Dist <- rep(c("Posterior", "Prior"),
               times = c(nrow(gdPosterior), nrow(gdPrior)))
gd$Dist <- factor(gd$Dist, levels = c("Posterior", "Prior"))

## Set labels for facet
levels(gd$Parameter)[levels(gd$Parameter) == "NCUR"] <- "italic(N)[CUR]"
levels(gd$Parameter)[levels(gd$Parameter) == "NANC"] <- "italic(N)[ANC]"
levels(gd$Parameter)[levels(gd$Parameter) == "GRATE"] <- "italic(G)"
levels(gd$Parameter)[levels(gd$Parameter) == "TDIV1"] <- "italic(T)[1]"
levels(gd$Parameter)[levels(gd$Parameter) == "TDIV2"] <- "italic(T)[2]"
levels(gd$Parameter)[levels(gd$Parameter) == "NM"] <- "italic(Nm)"
levels(gd$Parameter)[levels(gd$Parameter) == "MUT_SHAPE"] <- "italic(shape)"
levels(gd$Parameter)[levels(gd$Parameter) == "P_MEAN"] <- "mean~~italic(P)[GSM]"

## Make ggplot
g <- ggplot(data = gd,
            aes(x = Value, linetype = Dist, color = Dist)) +
    geom_line(stat = "density", alpha = 0.8) +
    scale_linetype_manual(values = c("solid", "dashed"), name = NULL) +
    scale_color_manual(values = c("grey10", "grey50"), name = NULL) +
    facet_wrap( ~ Parameter, ncol = 4, scales = "free",
               labeller = label_parsed) +
    expand_limits(y = 0) +
    labs(x = "", y = "Density") +
    theme_bw() +
    theme(legend.position = c(0.94, 0.895)) +
    theme(legend.background = element_rect(fill = "white", color = "black"))

system("mkdir -p ./figs")
pdf(file = "./figs/posterior_summary_model2C180421.pdf", width = 12, height = 6)
print(g)
dev.off()
}
#####################################################
## Make figs for 3 Nes

## Calculate mode and HPD of Ne at TDIV1
NT1 <- posterior$NCUR*exp(posterior$GRATE*posterior$TDIV1)

## Prepare data
gd2 <- data.frame(Parameter = rep(c("NCUR", "NT1", "NANC"), each = nrow(posterior)),
                 Value = c(posterior$NCUR, NT1, posterior$NANC))
gd2$Parameter <- factor(gd2$Parameter, levels = c("NCUR", "NT1", "NANC"))

## Make ggplot
g2 <- ggplot(data = gd2, aes(x = Value, linetype = Parameter)) +
    geom_line(stat = "density", alpha = 0.8) +
    expand_limits(y = 0) +
    labs(x = "Effective population size", y = "Density") +
    theme_bw() +
    scale_linetype_manual(values = c("solid", "dashed", "dotted"), name = NULL) +
    theme(legend.position = c(0.85, 0.8)) +
    theme(legend.background = element_rect(fill = "white", color = "black"))

pdf(file = "./figs/posterior_3Nes_model2C180221.pdf", width = 5, height = 4.5)
print(g2)
dev.off()

